<HTML>
<HEAD>
<TITLE>Debug Textarea</TITLE>
<meta http-equiv='Content-Type' content='text/html; charset=gb2312'>
</HEAD>
<style>
* {
	font-size: 12px
}
body {
	margin: 10px; padding: 0px
}
table.list{
	cursor: default;
	border:1px solid #cccccc
	background-color: #cccccc;
	border-collapse: collapse;
	border-Color: #cccccc;
}
</style>
<script language="javascript">
// Coded by windy_sk <windy_sk@126.com> 20040205

function reportError(msg,url,line) {
	var str = "You have found an error as below: \n\n";
	str += "Err: " + msg + " on line: " + line;
	alert(str);
	return true;
}

window.onerror = reportError;


document.onkeydown = function() {
	if(event.ctrlKey){
		switch(event.keyCode) {
			case 82: //r
				runcode();
				break;
			case 83: //s
				savecode();
				break;
			case 71: //g
				goto(prompt('Please input the line number', '1'));
				break;
			case 65: //a
				document.execCommand("SelectAll");
				break;
			case 67: //c
				document.execCommand("Copy");
				break;
			case 88: //x
				document.execCommand("Cut");
				break;
			case 86: //v
				document.execCommand("Paste");
				break;
			case 90: //z
				document.execCommand("Undo");
				break;
			case 89: //y
				document.execCommand("Redo");
				break;
			default:
				break;
		}
		event.keyCode = 0;
		event.returnValue = false;
	}
	return;
}


function show_ln(){
	var txt_ln	 = document.getElementById('txt_ln');
	var txt_main	 = document.getElementById('txt_main');
	txt_ln.scrollTop = txt_main.scrollTop;
	while(txt_ln.scrollTop != txt_main.scrollTop) {
		txt_ln.value += (i++) + '\n';
		txt_ln.scrollTop = txt_main.scrollTop;
	}
	return;
}


function editTab(){
	var code, sel, tmp, r;
	event.returnValue = false;
	sel =event.srcElement.document.selection.createRange();
	r = event.srcElement.createTextRange();

	switch (event.keyCode){
		case (8)	:
			if (!(sel.getClientRects().length > 1)){
				event.returnValue = true;
				return;
			}
			code = sel.text;
			tmp = sel.duplicate();
			tmp.moveToPoint(r.getBoundingClientRect().left, sel.getClientRects()[0].top);
			if(sel.parentElement() != tmp.parentElement()) return;;
			sel.setEndPoint('startToStart', tmp);
			sel.text = sel.text.replace(/^\t/gm, '');
			code = code.replace(/^\t/gm, '').replace(/\r\n/g, '\r');
			r.findText(code);
			r.select();
			break;
		case (9)	:
			if (sel.getClientRects().length > 1){
				code = sel.text;
				tmp = sel.duplicate();
				tmp.moveToPoint(r.getBoundingClientRect().left, sel.getClientRects()[0].top);
				if(sel.parentElement() != tmp.parentElement()) return;
				sel.setEndPoint('startToStart', tmp);
				sel.text = '\t'+sel.text.replace(/\r\n/g, '\r\t');
				code = code.replace(/\r\n/g, '\r\t');
				r.findText(code);
				r.select();
			}else{
				sel.text = '\t';
				sel.select();
			}
			break
		case (13)	:
			tmp = sel.duplicate();
			tmp.moveToPoint(r.getBoundingClientRect().left, sel.getClientRects()[0].top);
			if(sel.parentElement() != tmp.parentElement()) return;
			tmp.setEndPoint('endToEnd', sel);
			sel.text = '\r\n' + tmp.text.replace(tmp.text.replace(/^[\t ]+/g, ""),"");
			sel.select();
			break;
		default		:
			event.returnValue = true;
			break;
	}
	return;
}


function runcode() {
	var str = document.getElementById("txt_main").value;
	var code_win = window.open('about:blank');
	code_win.document.open();
	code_win.document.writeln("<script>");
	code_win.document.writeln("function reportError(msg,url,line){\nline-=14;\nvar str='You have found an error as below: \\n\\n';\nstr+='Err: '+msg+' on line: '+(line);\nalert(str);\nopener.goto(line);\nopener.focus();\nwindow.onerror=null;\nsetTimeout('self.close()',10);\nreturn true;\n}");
	code_win.document.writeln("window.onerror = reportError;");
	code_win.document.writeln("<\/script>");
	code_win.document.writeln(str);
	code_win.document.close();
	return;
}


function savecode() {
	var str = document.getElementById("txt_main").value;
	var code_win = window.open('about:blank','_blank','top=10000');
	code_win.document.open();
	code_win.document.writeln(str);
	code_win.document.close();
	code_win.document.execCommand('saveas','','code.html');
	code_win.close();
	return;
}


function goto(ln) {
	if(!/^\d+$/.test(ln) || ln==0) return;
	var obj = document.getElementById("txt_main");
	var rng = obj.createTextRange();
	var arr = obj.value.split(/\n/);
	if(ln>arr.length) ln = arr.length;
	var str_tmp = "";
	for(var i=0; i<ln-1; i++) {
		str_tmp += arr[i];
	}
	rng.moveStart('character',str_tmp.length);
	str_tmp = "";
	for(i=ln; i<arr.length; i++) {
		str_tmp += arr[i];
	}
	rng.moveEnd('character',-str_tmp.length); 
	rng.select();
	return;
}

window.onload = function() {document.getElementById("txt_main").value = "<script>\nalert(')\n<\/script>";}
</script>
<BODY>
<table width='600' class='list' border='1' bgcolor='#eeeeee' bordercolorlight='#000000' bordercolordark='#FFFFFF' cellpadding='0' cellspacing='0'>
  <tr bgcolor='#cccccc'> 
    <td colspan='2' height='20' align='center'><b>Debug Textarea</b></td>
  </tr>
  <tr> 
    <td colspan='2'>
        <table width='95%' border='0' align='center' >
	  <tr> 
	    <td align='center'><br />
	      <textarea id='txt_ln' name='content' rows='10' style='width:40px;overflow:hidden;height:200px;border-right:0px;text-align:right;line-height:14px' onselectstart='this.nextSibling.focus();return false' readonly></textarea><textarea id='txt_main' name='content' rows='10' cols='80' onkeydown='editTab()' onkeyup='show_ln()' onscroll='show_ln()' wrap='off' style='overflow:auto;height:200px;padding-left:5px;border-left:0px;line-height:14px'></textarea>
	      <script>for(var i=1; i<=20; i++) document.getElementById('txt_ln').value += i + '\n';</script>
	    </td>
	  </tr>
          <tr> 
            <td align='center'><br />
              <input type='button' value=' ÔË ÐÐ ' onclick='runcode()' accesskey='r'>&nbsp;&nbsp;
              <input type='button' value=' ±£ ´æ ' onclick='savecode()' accesskey='s'>&nbsp;&nbsp;
              <input type='button' value=' Ìø ×ª ' onclick="goto(prompt('Please input the line number', '1'))"  accesskey='g'>&nbsp;&nbsp;
            </td>
          </tr>
        </table>
    </td>
  </tr>
</table>
</BODY>
</HTML>
